﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Net; 
using System.IO; 
using System.Threading;

namespace Encrypted_Mutlicasting_Chat_System
{
    public class Multicasting
    {
       private const int SendingPort = 9090;
       private const int ListeningPort = 9090;
       private byte[] Message = new byte[0];
       private string MulticastIP;
       private Thread th;
       private Socket Listener_Socket;
       private bool Connceted = false;

       public Multicasting(string Multicast_IP)
       {
           MulticastIP = Multicast_IP;
       }
       public byte[] Get_The_Received_Bytes
        {
            get { return Message; } 
        }
       private void Listening_Service()
        {
            try
            {
                Listener_Socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                IPEndPoint ipend = new IPEndPoint(IPAddress.Any, ListeningPort);
                Listener_Socket.Bind(ipend);
                MulticastOption mo = new MulticastOption(IPAddress.Parse(MulticastIP));
                Listener_Socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.AddMembership, mo);
                while (Connceted)
                {
                    try
                    {
                        // Receiving
                        byte[] buffer = new byte[128];
                        EndPoint ip = (EndPoint)ipend;
                        Listener_Socket.ReceiveFrom(buffer, ref ip);
                        Message = buffer;
                    }
                    catch (Exception) { }
                }
            }
            catch (Exception) { StopListening_Service(); StartListening_Service(); }
        }
        public void StartListening_Service()
        {
           Connceted = true;
           th = new Thread (new ThreadStart(Listening_Service));
           th.IsBackground = true;
           th.Start();
        }
        public void StopListening_Service()
        {
            if (th != null)
            {
                Connceted = false;
                Listener_Socket.Close();
                th.Abort();
            }
        }
        public void Send_The_Encrypted_MSG(byte[] Encrypted_MSG)
         {
             try
             {
                 Socket Sender_Socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                 Sender_Socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.MulticastLoopback, true);
                 IPEndPoint ipend = new IPEndPoint(IPAddress.Parse(MulticastIP), SendingPort);
                 Sender_Socket.SendTo(Encrypted_MSG, ipend);
                 Sender_Socket.Close();
             }
             catch (Exception) {}
         }
    }
}
